set_window_text :-
  set_text("AI Unravels the Chess, step="+G_Time+(G_Freeze =:= 1 -> " (Agent is Freezed)" else "")+ (G_Pause =:= 1 -> (G_One_Step > 1 -> " (One Transition)" else " (Pause)") else ""), _).

check_pause:-
  (G_Pause =:= 1 ->
    (G_One_Step =:= 1 ->
      G_One_Step := 0
    else
      G_One_Step =:= 2,
      (G_Time =:= time_last(G_Sel) -> G_One_Step := 0)
    )
  ).

menu_agent(init) :-
  menu(normal, action(menu_freeze), text("&Freeze\tZ") ).

menu_world(init) :-
  menu(normal, action(menu_only_this), text("&Only this will be observable\tX") ),
  menu(normal, action(menu_with_randomness), text("&With randomness") ).

menu_time(init) :-
  menu(normal, action(menu_pause), text("&Pause\tP") ),
  menu(separator),
  menu(normal, action(menu_one_step), text("&One Step\tO") ),
  menu(separator),
  menu(normal, action(menu_one_transition), text("&One Transition\tI") ),
  menu(separator),
  menu(normal, action(menu_slow_motion), text("&Slow Motion\tS") ),
  menu(checked, action(menu_normal_speed), text("&Normal Speed") ),
  menu(normal, action(menu_fast_speed), text("&Fast Speed\tF") ).

menu_show(init) :-
  menu(normal, action(menu_results), text("Results &List\tL") ).

menu_help(init) :-
  menu(normal, action(menu_description), text("&Description") ),
  menu(normal, action(menu_notetions), text("&Notetions") ),
  menu(normal, action(menu_article), text("&Article") ).

menu_shift(init) :-
  menu(normal, action(sift_left), text("&Left\tPg Up") ),
  menu(normal, action(sift_right), text("&Right\tPg Down") ).

menu_restart(press) :-
  init_all,
  set_window_text,
  update_window(_).

menu_fast_speed(press) :-
  G_FastSpeed:=(G_FastSpeed=:=1 -> 0 else 1),
  change_speed.
menu_normal_speed(press) :-
  (G_FastSpeed=\=0->
    G_FastSpeed:=0,
    change_speed
  ).
menu_slow_motion(press) :-
  G_FastSpeed:=(G_FastSpeed=:= -1 -> 0 else -1),
  change_speed.

change_speed:-
  modify_menu(G_Menu_Time, 8+G_Last_Speed, normal, _ ),
  modify_menu(G_Menu_Time, 8+G_FastSpeed, checked, _ ),
  G_Last_Speed := G_FastSpeed,
  Interval := (G_FastSpeed =:= 1 -> 0.01 else (G_FastSpeed =:= 0 -> 0.5 else 2)),
  kill_timer(_, G_Timer),
  G_Timer := set_timer(_, Interval, time_func).

menu_results(press) :-
  G_Results := 1 - G_Results,
  modify_menu(G_Menu_Show, 1, (G_Results =:= 1 -> checked else normal), _ ),
  update_window(_).

menu_freeze(press) :-
  G_Freeze := 1 - G_Freeze,
  modify_menu(G_Menu_Agent, 1, (G_Freeze =:= 1 -> checked else normal), _ ),
  set_window_text.

menu_only_this(press) :-
  (true ->
    Observed := G_Sel,
    (Observed > 7, Observed < G_M, G_Observed =\= Observed ->
      G_Freeze := 1,
      modify_menu(G_Menu_Agent, 1, checked, _ ),
      G_Observed := Observed
    else
      G_Observed := 0
    )
  ), 
  update_window(_).

menu_with_randomness(press) :-
  G_with_Randomness := 1 - G_with_Randomness,
  modify_menu(G_Menu_World, 2, (G_with_Randomness =:= 1 -> checked else normal), _ ).

menu_pause(press) :-
  G_Pause := 1 - G_Pause,
  modify_menu(G_Menu_Time, 1, (G_Pause =:= 1 -> checked else normal), _ ),
  G_One_Step := 0,
  set_window_text.

menu_one_step(press) :-
  (G_Pause =:= 1 ->
    G_One_Step := 1
  ),
  time_func(end).

menu_one_transition(press) :-
  G_Pause := 1,
  modify_menu(G_Menu_Time, 1, checked, _ ),
  G_One_Step := 2,
  time_func(end).

menu_description(press):-
  message("AI Unravels the Chess",

  "What is this program?

This is an attempt to build AI. First, we need to learn how to describe the world. For this purpose, we need a special language for describing worlds. This program is an attempt to create such a special language and describe through it the world of chess game.",i).

menu_notetions(press):-
  message("AI Unravels the Chess - Notetions",

  "a0=0 means that the action at the current step is zero.

v0=0 means that the observation at the current step is zero.

a1 means the action at the previous step (the current minus one).

a0=\\=0 means that the action at the current step is not zero.

a0*0 means that the action \"zero\" at the current step is correct.",i).

menu_article(press) :-
  shell_execute("Demonstration.pdf").

sift_left(press):-
  move_model(-1).
sift_right(press):-
  move_model(1).

move_model(Direction):-
  G_Sel := G_Sel + Direction,
  G_Sel_Tr := -1,
  (G_Sel < 0 -> G_Sel := 0),
  (G_Sel > G_M-1 -> G_Sel := G_M-1),
  update_window(_).

win_func(init) :-
  menu(normal, action(menu_restart), text("&Restart") ),
  G_Menu_Agent := menu( pop_up, action(menu_agent), text("&Agent") ),
  G_Menu_World := menu( pop_up, action(menu_world), text("&World") ),
  G_Menu_Time := menu( pop_up, action(menu_time), text("&Time") ),
  G_Menu_Show := menu( pop_up, action(menu_show), text("&Show") ),
  menu( pop_up, action(menu_shift), text("&Shift") ),
  menu( right, pop_up, action(menu_help), text("&Help") ),
  G_Timer := set_timer(_, 0.5, time_func).

win_func(size(X,Y)):-
  (Y>0 -> G_Zoom := Y/967),
  update_window(_).

win_func(key_down(36, Rep)):- % (home)
  G_Sel_Show := (G_Sel_Show + 1) mod 3,
  update_window(_).
win_func(key_down(37, Rep)):- % left
  (all_traces(G_Sel)<10, G_Sel_Tr_H=:=2->
    G_Sel_Tr_H := 0
  else (G_Sel_Tr_H>0 ->
    G_Sel_Tr_H := G_Sel_Tr_H-1
  )),
  update_window(_).
win_func(key_down(39, Rep)):- % right
  (all_traces(G_Sel)<10, G_Sel_Tr_H=:=1->
    G_Sel_Tr_H := 3
  else (G_Sel_Tr_H<4 ->
    G_Sel_Tr_H := G_Sel_Tr_H+1
  )),
  update_window(_).
win_func(key_down(33, Rep)):- % left (page up)
  sift_left(press).
win_func(key_down(46, Rep)):- % left (delete)
  sift_left(press).
win_func(key_down(35, Rep)):- % left (end)
  sift_left(press).
win_func(key_down(34, Rep)):- % right (page down)
  sift_right(press).
win_func(key_down(38, Rep)):- % up
  (G_Sel_Tr> -1 -> G_Sel_Tr := G_Sel_Tr-1, (G_Sel_Tr =:= 8 -> G_Sel_Tr_H := 1) else G_Sel_Tr_H := 1),
  update_window(_).
win_func(key_down(40, Rep)):- % down
  (G_Sel_Tr< all_traces(G_Sel)-1 -> G_Sel_Tr := G_Sel_Tr+1, (G_Sel_Tr =:= 9 -> G_Sel_Tr_H := 2)),
  update_window(_).
win_func(key_down(82, Rep)):- % R
  menu_restart(press).
win_func(key_down(90, Rep)):- % Z
  menu_freeze(press).
win_func(key_down(88, Rep)):- % X
  menu_only_this(press).
win_func(key_down(80, Rep)):- % P
  menu_pause(press).
win_func(key_down(79, Rep)):- % O
  menu_one_step(press).
win_func(key_down(73, Rep)):- % I
  menu_one_transition(press).
win_func(key_down(83, Rep)):- % S
  menu_slow_motion(press). 
win_func(key_down(70, Rep)):- % F
  menu_fast_speed(press). 
win_func(key_down(76, Rep)):- % L
  menu_results(press). 

win_func(mouse_click(X, Y)):-
  N := 2*G_ChS,
  (Y<G_Zoom*66, Y>G_Zoom*8 ->
    X2 := (G_Zoom_Font=:=1 -> X else X + 36),
    (abs((X2+N//4) mod N - N//2) =< N//4 ->
      G_Sel := X2 // N - 2,
      G_Sel_Tr := -1
    )
  else (Y<G_Zoom*950, Y>G_Zoom*750 ->
    I := X//N - 33,
    (I >= 0, I < 8 ->
      J := 7 - (Y - G_Zoom*750)//(G_Zoom*25), 
      active(1) := 2**I, active_previous(1) := 2**I,
      active(2) := 2**J, active_previous(2) := 2**J
    )
  else (Y<G_Zoom*(10*68+80), Y>G_Zoom*80 ->
    (X<G_Zoom*600 ->
      G_Sel_Show := (G_Sel_Show + 1) mod 3
    else
      Num := (Y/G_Zoom -80) // 68,
      (Num=:=0 ->
        I := (X - G_Zoom*600)//G_ChS,
        (I < 9 ->
          G_Sel_Tr_H := 0
        else (I < 13 ->
          G_Sel_Tr_H := 1
        else (I < 17 ->
          G_Sel_Tr_H := 2
        else (I < 24 ->
          G_Sel_Tr_H := 3
        else
          G_Sel_Tr_H := 4
        ))))
      else 
        Num2 := (G_Sel_Tr_H =:= 2, all_traces(G_Sel)>9 -> Num+8 else Num-1),
        (G_Sel_Tr =:= Num2->
          G_Sel_Tr := -1
        else
          G_Sel_Tr := Num2
        )
      )
    )
  ))),
  update_window(_).

win_func(paint):-
  color_text(_, rgb(0,0,0)),
  text_out(" ", pos(0,10)),
  (G_Zoom_Font=:=1 -> text_out("   ")),
  for(I, 0, G_M-1),
    (make_colors(I) -> true),
    names(I, Name, _, _, _),
    text_out(Name+" "),
    fail.
win_func(paint):-
  color_text(_, rgb(0,0,255)),
  color_text_back(_, system_color(window)),
  text_out(" ", pos(0,40)),
  (G_Zoom_Font=:=1 -> text_out("   ")),
  for(I, 0, G_M-1),
    (I > 6, I < 26->
      text_out((observable(I)-> (G_Observed > 0 -> "x " else "* ") else ". ")) 
    else (I =:= 5->
      color_text(_, rgb(255,0,0)),
      text_out(("2 ")) 
    else (I =:= 6->
      text_out(("1 ")), 
      color_text(_, rgb(0,0,255))
    else
      (T := find_first_1_in(active_previous(I))->
        true
      else
        T := " "
      ),
      text_out(T+" ")
    ))),
    fail.
  
win_func(paint):-
  show_line(0, "views    ", 0, buf_views).
win_func(paint):-
  show_line(0, "incorrect", 40, buf_incorrect).
win_func(paint):-
  show_line(0, "actions  ", 80, buf_actions).
win_func(paint):-
  show_line(G_Sel, "arrows   ", 120, buf_arrows).
win_func(paint):-
  show_line(G_Sel, "the trace", 160, buf_the_trace).

win_func(paint):-
  X := 990,
  text_out("       ", pos(G_Zoom_Font*X, G_Zoom*700)),
  make_chess_squre(X, -8, 9),
  for(J, 0, 7),
    for(I, 0, 7),
      make_chess_squre(X, I, J),
      fail.

win_func(paint):-
  color_text_back(_, system_color(window)),
  G_Results =:= 0,
  (G_Sel =:= 5 ->
    show_grid(8, 8)
  else (G_Sel =:= 6 ->
    show_grid(2, 1)
  )),
  fail.

win_func(paint):-
  G_ChS := text_out_size("x"), 
  (G_Zoom_Font=:=1 ->
    N := 4+2*G_Sel 
  else
    N := 1+2*G_Sel
  ),
  I := 2*find_first_1_in(active_previous(1)),
  J := find_first_1_in(active_previous(2)),
  X := G_Zoom_Font*990,
  Y := G_Zoom*(925-25*J),
  (active_previous(4)=:=1-> 
    pen(2, rgb(255, 0, 0))
  else
    pen(2, rgb(0, 0, 255))
  ),
  line(X+I*G_ChS-2, Y, X+(I+2)*G_ChS+1, Y, X+(I+2)*G_ChS+1, Y+G_Zoom_Font*26, X+I*G_ChS-2, Y+G_Zoom_Font*26, X+I*G_ChS-2, Y),
  pen(2, rgb(255, 0, 0)),
  line(N*G_ChS-2, 39, (N+1)*G_ChS+1, 39, (N+1)*G_ChS+1, 65, N*G_ChS-2, 65, N*G_ChS-2, 39),
  (G_Sel > 4, G_Sel < 7, G_Results =:= 0 ->
    (active_previous(4)=:=2, G_Sel =:= 5-> 
      pen(8, rgb(0, 0, 255))
    else
      pen(8, rgb(255, 0, 0))
    ),
    (G_Sel =:= 5 ->
      X := G_Zoom*(20 + 35*I),
      Y := G_Zoom*(610 - 70*J)
    else
      X := G_Zoom*(300-70 + 70*find_first_1_in(active_previous(3))),
      Y := G_Zoom*(400-35)
    ),
    S := 70*G_Zoom,
    line(X, Y, X+S, Y, X+S, Y+S, X, Y+S, X, Y)
  ),
  fail.

win_func(paint):-
  G_Results =:= 0,
  (G_Sel > 4, G_Sel < 7 ->
    show_memory_rules
  ),
  fail.

win_func(paint):-
  G_Results =:= 0,
  brush(system_color(window)),
  (all_traces(G_Sel)>4; G_Sel=:=15 ->
    Y1 := 1,
    text_out(" ", pos(G_Zoom*600, G_Zoom*90)),
    draw_labels
  else 
    Y1 := (all_arrows(G_Sel)<4-> 1 else 0)
  ),
  for(Event, 0, all_arrows(G_Sel)-1),
    (G_Sel_Tr_H=:=0; all_traces(G_Sel)<5, G_Sel=\=15 ->
      Y := (Y1+Event)*70+20,
      makeColor(Event, _, Color),
	  (2**Event/\buf_arrows(50*G_Sel + G_Time mod 50) =\= 0 ->
        pen(10, Color)
      else
        pen(3, Color)
      ),
      line(G_Zoom*600, G_Zoom*(70+Y), G_Zoom*1000, G_Zoom*(70+Y)),
      line(G_Zoom*970, G_Zoom*(80+Y), G_Zoom*1000, G_Zoom*(70+Y), G_Zoom*970, G_Zoom*(60+Y)),
      color_text(_, rgb(255,0,0)),
      Event2 := events(G_T*G_Sel+Event),
      Star := (event_is_true(Event2, 0, 0)-> "*" else " "),
      text_out(Star+2**Event+". ", pos(G_Zoom*600, G_Zoom*(90+Y))),
      print_event(no, Event2, 0)
    ),
    for(I, 0, G_S-1),
	  for(J, 0, G_S-1),
	    links(G_S*G_S*G_Sel+G_S*I+J)/\2**Event =\= 0,
		R := G_Zoom*(active_previous(G_Sel)/\2**J=\=0 -> 40 else 25),
         (I=:=J->
		  loop(I, R, Event)
         else
		  arrow(I, J, R, Event)
         ),
		fail.

win_func(paint):-
  G_Results =:= 0,
  (observable(G_Sel) ->
    color_text(_, rgb(0,0,0))
  else
    color_text(_, rgb(255,0,0))
  ),
  names(G_Sel, _, Name, _, _),
  text_out(Name, pos(G_Zoom*70, G_Zoom*110)),
  G_Sel =\= 5, G_Sel =\= 6,
  (all_traces(G_Sel)>4; G_Sel =:= 15 ->
    (G_Sel_Tr_H=:=2, all_traces(G_Sel)>9 ->
      A:= 9, B:= all_traces(G_Sel)-1,
      Y1 := -7
    else (G_Sel_Tr_H=:=1; G_Sel_Tr_H=:=2 ->
      A:= 0, B:= min(8, all_traces(G_Sel)-1),
      Y1 := 2
    else (G_Sel_Tr_H>2->
      A:= 0, B:= 0,
      Y1 := 2
    else
      fail
    )))
  else
    color_text(_, rgb(255,0,0)),
    text_out("The trace", pos(G_Zoom*600, G_Zoom*390)),
    A:= 0, B:= all_traces(G_Sel)-1,
    Y1 := 6
  ),
  for(Event, A, B),
    Y := (Y1+Event)*68,
    (G_Sel_Tr_H>2, G_Sel>4, G_Sel<16 ->
      (G_Sel_Tr_H =:= 3 ->
        Event2 := enter(G_Sel)
      else
        Event2 := exit(G_Sel)
      )
    else
      Event2 := events(G_T*G_Sel+Event+4)
    ),
    Cell := events2(10*Event2),
    Delay := true_value((Cell//(2*G_S)) mod 10 =:= 2),
    Implication := yes,
    (G_Sel_Tr_H > 2, G_Sel>4, G_Sel<16 ->
      Implication := no,
      (event_is_true(Event2, 0, Delay)->
        Trace := 1,
        Star := "*"
      else
        Trace := 5,
        Star := " "
      )
    else (event_is_true(Event2, 1, Delay)->
      States := (Delay =:= 1; G_Time =\= time_last(G_Sel) -> active_previous(G_Sel) else active_last(2*G_Sel+1)),
      (Trace := states(G_Tr*G_S*G_Sel+G_Tr*find_first_1_in(States)+Event) ->
        if_all_agree(G_Sel, States, Event, Trace)
      else
        Trace := 5
      ),
      Star := "*"
    else
      Trace := 5,
      Star := " "
    )),
    makeColor(_, Trace, Color),
    pen(10, Color),
    line(G_Zoom*600, G_Zoom*(10+Y), G_Zoom*1000, G_Zoom*(10+Y)),
    color_text(_, rgb(255,0,0)),
    (G_Sel_Tr=:=Event, G_Sel_Tr_H<3->
      color_text_back(_, rgb(255, 255, 0))
    ),
    text_out(Star+(Event+1)+". ", pos(G_Zoom*600,G_Zoom*(30+Y))),
    print_event(Implication, Event2, 0),
    (G_Sel_Tr=:=Event->
      color_text_back(_, system_color(window))
    ),
    fail.

win_func(paint):-
  G_Results =:= 1,
  color_text(_, rgb(0,0,0)),
  text_out("everytime", pos(G_Zoom*80,G_Zoom*90)),
  text_out(" never", pos(G_Zoom*250,G_Zoom*90)),
  text_out(" higher", pos(G_Zoom*450,G_Zoom*90)),
  text_out(" lower", pos(G_Zoom*600,G_Zoom*90)),
  color_text(_, rgb(255,0,0)),
  text_out("collisions", pos(G_Zoom*750,G_Zoom*90)),
  color_text(_, rgb(0,0,255)),
  text_out("possibility", pos(G_Zoom*950,G_Zoom*90)),
  make_line(1, 100),
  make_line(2, 250),
  make_line(3, 450),
  make_line(4, 600),
  make_table(160, 0),
  make_table(190, 4),
  fail.

win_func(paint):-
  pen(1, rgb(0, 255 ,0)),
  line(G_Zoom*10, G_Zoom*865, G_Zoom_Font*970, G_Zoom*865),
  (G_Results =:= 1 ->
    line(G_Zoom*110, G_Zoom*160, G_Zoom*110, G_Zoom*740),
    line(G_Zoom*460, G_Zoom*160, G_Zoom*460, G_Zoom*740),
    line(G_Zoom*800, G_Zoom*160, G_Zoom*800, G_Zoom*740),
    line(G_Zoom*950, G_Zoom*160, G_Zoom*950, G_Zoom*740)
  ),
  G_Results =:= 0,
  pen(3, rgb(0,0,0)),
  color_text(_, rgb(0,0,0)),
  for(I, 0, G_S-1),
    states(G_Tr*G_S*G_Sel+G_Tr*I)>0,
    calcCoords(X, Y, I),
	(active_previous(G_Sel)/\2**I=:=0 ->
      makeColor(_, 6, Color),
      R := G_Zoom*25
    else (restricted(G_Sel)/\2**I=\=0 ->
      makeColor(_, 7, Color),
      R := G_Zoom*35
    else
      makeColor(_, 5, Color),
      R := G_Zoom*40,
      (G_Time mod 2 =:= 1 -> pen(6, rgb(0,0,0)))
    )),
    brush(Color),
    ellipse(X-R, Y-R, X+R, Y+R),
    draw_trace(I, X, Y, R),
	(active_previous(G_Sel)/\2**I=\=0 ->
      text_out(I, pos(X-6, Y-10))
    ),
    pen(3, rgb(0, 0, 0)),
    fail.

label(0, " Events ").
label(1, " Traces ").
label(3, " Enter ").
label(4, " Exit ").
label(5, "").

draw_labels:-
  label(I, Label),
  (I=:=1 ->
    (all_traces(G_Sel)>9 ->
      draw_labels2(G_Sel_Tr_H=:=1, " T1 "),
      draw_labels2(G_Sel_Tr_H=:=2, " T2 ")
    else
      draw_labels2((G_Sel_Tr_H=:=1; G_Sel_Tr_H=:=2), Label)
    )
  else
    draw_labels2(G_Sel_Tr_H=:=I, Label)
  ),
  fail.
draw_labels.

draw_labels2(Condition, Label):-
  (Condition ->
    color_text_back(_, rgb(0, 255, 0)),
    text_out(Label),
    color_text_back(_, system_color(window))
  else
    text_out(Label)
  ).

make_table(Y, Row1):-
  for(Row, Row1, Row1+G_K-1),
    color_text(_, rgb(255,0,0)),
    (Row1 =:= 0 ->
      Star := (Row =:= buf_views(G_Time mod 50) -> "*" else " "),
      Text := (G_K > 2, Row>0 -> string_from_ASCII(Row-1+first_ASCII("x")) else Row)
    else
      Star := (Row-4 =:= buf_actions(G_Time mod 50) -> "*" else " "),
      Text := (G_K > 2, Row-4>0 -> string_from_ASCII(Row-5+first_ASCII("a")) else Row-4)
    ),
    text_out(Star+Text+". ", pos(G_Zoom*50, G_Zoom*(Y+Row*70))),
    color_text(_, rgb(0,0,0)),
    X := 120, I := 0,
    for(Col, 0, 7),
      (Col mod 3 =:= 2 ->
        color_text(_, rgb(0,0,255)),
        (Row1 =:= 0, results0(4*Row) =:= G_Max1 ->
          color_text_back(_, rgb(255,255,0)),
          text_out(" "+results0(4*Row+2*I)+" ", pos(G_Zoom*X, G_Zoom*(Y+Row*70))),
          color_text_back(_, rgb(255,255,255))
        else (Row1 =:= 4, results0(4*Row) =< G_Max2 ->
          (results0(4*Row) =:= G_Max2 ->
            color_text_back(_, rgb(255,255,0))
          else
            color_text_back(_, rgb(255,128,128))
          ),
          text_out(" "+results0(4*Row+2*I)+" ", pos(G_Zoom*X, G_Zoom*(Y+Row*70))),
          color_text_back(_, rgb(255,255,255))
        else
          text_out(" "+results0(4*Row+2*I)+" ", pos(G_Zoom*X, G_Zoom*(Y+Row*70)))
        )),
        color_text(_, rgb(0,0,0)),
        I := 1
      else (Col =:= 6 ->
        Collision1 := min(results0(4*Row + 0)+results0(4*Row + 1), results0(4*Row + 1)),
        Collision2 := min(results0(4*Row + 2)+results0(4*Row + 3), results0(4*Row + 3)),
        (Collision1+Collision2 > 0 ->
          Text := Collision1+"+"+Collision2+"="+(Collision1+Collision2)
        else
          Text := "."
        ),
        color_text(_, rgb(255,0,0)),
        text_out(Text, pos(G_Zoom*X, G_Zoom*(Y+Row*70)))
      else (Col =:= 7 ->
        (Row1 =:= 0, results0(4*Row) =:= G_Max1 ->
          color_text(_, rgb(0,0,255)),
          Min1 := min_integer,
          Text := "",
          create_probability(Min1, _, _, _, Row, Text, paint),
          text_out(Text, pos(G_Zoom*X, G_Zoom*(Y+Row*70)))
        else (Row1 =:= 4 ->
          color_text(_, rgb(255,0,0)),
          text_out(2**(Row-4)+". ", pos(G_Zoom*X, G_Zoom*(Y+Row*70))),
          color_text(_, rgb(0,0,255)),
          (results0(4*Row) >= G_Max2 ->
            (results0(4*Row) > G_Max2 ->
              Text := "one"
            else (results0(4*Row+2) =:= 0 ->
              Text := "one"
            else (results0(4*Row+2) < 0 ->
              Text := "0.25"
            else
              Text := "one"
            )))
          else
            Text := " 0 "
          ),
          (G_Incorrect /\ 2**(Row-4) =\= 0 ->
            color_text_back(_, rgb(255,128,128)),
            text_out(Text),
            color_text_back(_, rgb(255,255,255))
          else
            text_out(Text)
          )
        ))
      else
        ((Col - I) mod 2 =:= 0 ->
          Result0 := results0(4*Row + Col - I) + results0(4*Row + Col - I + 1)
        else
          Result0 := results0(4*Row + Col - I)
        ),
        Text := (Result0 =\= 0 -> Result0 else "."),
        Result := results(32*G_Sel+4*Row + Col - I),
        (Result =\= 0 -> Text := Text+" ("+Result+")"),
        text_out(Text, pos(G_Zoom*X, G_Zoom*(Y+Row*70)))
      ))),
      X := X + (Col mod 3 > 0 -> 100 else 150),
      fail.
make_table(Y, Row1).

make_line(Col, X):-
  makeColor(_, Col, Color),
  pen(10, Color),
  line(G_Zoom*X, G_Zoom*130, G_Zoom*(X+130), G_Zoom*130).

draw_trace(I, X, Y, R):-
  (all_traces(G_Sel)<3 ->
    draw_trace2(I, X, Y, R)
  else (all_traces(G_Sel)<5 ->
    draw_trace4(I, X, Y, R)
  else (all_traces(G_Sel)=:=5 ->
    draw_trace5(I, X, Y, R)
  else
    draw_trace5p(I, X, Y, R)
  ))).
draw_trace(I, X, Y, R).

draw_trace2(I, X, Y, R):-
  F := R/25,
  for(Num, 0, 1),
    (G_Sel_Tr =:= -1; G_Sel_Tr mod 5 =:= Num),
    X1 := F*10,
    Y1 := F*(-5+10*Num),
    State:=states(G_Tr*G_S*G_Sel+G_Tr*I+Num),
    (State=\=5->
      makeColor(_, State, Color),
      pen(F*11, Color),
      line(X-R+X1,Y+Y1,X+R-X1,Y+Y1)
    ),
    fail.

draw_trace4(I, X, Y, R):-
  F := R/25,
  for(Num, 0, 3),
    (G_Sel_Tr =:= -1; G_Sel_Tr mod 5 =:= Num),
    X1 := F*(Num>0, Num<3 -> 10 else 15),
    Y1 := F*(-15+10*Num),
    State:=states(G_Tr*G_S*G_Sel+G_Tr*I+Num),
    (State=\=5->
      makeColor(_, State, Color),
      pen(F*11, Color),
      line(X-R+X1,Y+Y1,X+R-X1,Y+Y1)
    ),
    fail.

draw_trace5(I, X, Y, R):-
  F := R/25,
  for(Num, 0, 4),
    (G_Sel_Tr =:= -1; G_Sel_Tr mod 5 =:= Num),
    X1 := F*(Num=:=2 -> 7 else (Num>0, Num<4 -> 10 else 15)),
    Y1 := F*(-15+8*Num),
    State:=states(G_Tr*G_S*G_Sel+G_Tr*I+Num),
    (State=\=5->
      makeColor(_, State, Color),
      pen(F*8, Color),
      line(X-R+X1,Y+Y1,X+R-X1,Y+Y1)
    ),
    fail.

draw_trace5p(I, X, Y, R):-
  F := R/25,
  for(Num, 0, 4),
    (G_Sel_Tr =:= -1; G_Sel_Tr mod 5 =:= Num),
    X1 := F*(Num=:=2 -> 7 else (Num>0, Num<4 -> 10 else 15)),
    Y1 := F*(-15+8*Num),
    State:=states(G_Tr*G_S*G_Sel+G_Tr*I+Num),
    State2:=states(G_Tr*G_S*G_Sel+G_Tr*I+Num+5),
    State3:= (Num<4 -> states(G_Tr*G_S*G_Sel+G_Tr*I+Num+10) else 5),
    (State=\=5, G_Sel_Tr < 5 ->
      makeColor(_, State, Color),
      pen(F*8, Color),
      line(X-R+X1,Y+Y1,X-F*3,Y+Y1)
    ),
    (State2=\=5, (G_Sel_Tr =:= -1; G_Sel_Tr > 4, G_Sel_Tr < 10)->
      makeColor(_, State2, Color),
      pen(F*8, Color),
      line(X+F*3,Y+Y1,X+R-X1,Y+Y1)
    ),
    (State3=\=5, (G_Sel_Tr =:= -1; G_Sel_Tr > 9)->
      makeColor(_, State3, Color),
      pen(F*8, Color),
      line(X+F*3,Y+Y1,X+R-X1,Y+Y1)
    ),
    fail.

print_event(Implication, Event2, Count):-
  (conjunction(Event2, _, Name, _); implication(Event2, _, Name, _)),
  (G_Sel_Show =\=1, Name =\= "" ->
    color_text(_, rgb(0,128,0)),
    text_out(Name + " : ")
  ),
  (G_Sel_Show =\=2 ->
    color_text(_, rgb(0,0,0)),
    print_event2(Implication, Event2, Count)
  ).

print_event2(Implication, Event2, Count):-
  Cell := events2(10*Event2+Count),
  (Cell =\= max_integer ->
    print_event2(Implication, Event2, Count+1),
    PosCell := Cell//2,
    Atom := PosCell//G_S//10,
    Type := (PosCell//G_S) mod 10,
    (Count=:=0 ->
      (Implication=yes -> text_out(" => ")),
      color_text(_, rgb(0,0,255))
    ),
    Value := PosCell mod G_S,
    (G_K > 2, Value > 0, Type =\= 3, Type =\= 5 ->
      Value := string_from_ASCII(Value-1+first_ASCII((Type =:= 2 -> "x" else "a")))
    ),
    (Type =:= 1 ->
      text_out("a" + Atom + (Cell mod 2 =:= 0 -> "*" else "#") + Value)
    else (Type =:= 3 ->
      text_out("m" + Atom + (Cell mod 2 =:= 0 -> "=" else "=\\=") + Value)
    else (Type =:= 4 ->
      names(Atom, _, _, Name, _),
      text_out((Cell mod 2 =:= 0 -> "" else "!") + "ob(" + Name + ")")
    else (Type =:= 5 ->
      names(Atom, _, _, Name, _),
      text_out((Cell mod 2 =:= 0 -> "" else "!") + Name + " in m" + Value + "(here)")
    else (Type =:= 6 ->
      conjunction(Atom, Ind, _, _),
      text_out((Cell mod 2 =:= 0 -> "" else "!") + print(Ind) )
    else
      text_out((Type =:= 2 -> "v" else "a") + Atom + (Cell mod 2 =:= 0 -> "=" else "=\\=") + Value)
    ))))),
    (Count>0, not(Count =:= 1, Implication=yes) ->
      text_out(" & ")
    )
  ).

show_line(Model, Title, Y, Buffer):-
  color_text(_, rgb(0,0,0)),
  text_out(" "+Title+" -> ", pos(0,G_Zoom*(750+Y))),
  for(N, 1, 50),
    ((N+G_Time) mod 3 =:=2 -> color_text(_, rgb(255,0,0))),
    ((N+G_Time) mod 3 =\=2 -> color_text(_, rgb(0,0,255))),
    Value := Buffer(50*Model + (N+G_Time) mod 50),
    (Value=:=0 ->
      text_out(".")
    else (Y=\=0, Y=\=80 ->
      text_out(hex_string(15/\Value))
    else (G_K =:= 2 ->
      text_out("*")
    else (Y=:=0 ->
      text_out(string_from_ASCII(Value-1+first_ASCII("x")))
    else
      text_out(string_from_ASCII(Value-1+first_ASCII("a")))
    )))),
    fail.

loop(I, R, Event):-
  calcCoords(X1,Y1,I),
  calcCoords(X2,Y2,0),
  D:= sqrt((X1-X2)**2+(Y1-Y2)**2),
  [A,B]:==[X2-X1,Y2-Y1]/D,
  [X5,Y5]:==[X1,Y1]+(-1.7*R)*[A,B],

  [A2,B2]:==roll(pi+0.688,[A,B]),
  [X3,Y3]:==[X1,Y1]+R*[A2,B2],
  [X4,Y4]:==[X1,Y1]+(R+20*G_Zoom)*[A2,B2],
  [X4a,Y4a]:==[X4,Y4]+10*G_Zoom*[-1*B2,A2],
  [X4b,Y4b]:==[X4,Y4]+10*G_Zoom*[B2,-1*A2],
  makeColor(Event, _, Color),
  (active_last(2*G_Sel+0)/\2**I=\=0, active_last(2*G_Sel+1)/\2**I=\=0, 2**Event/\events_last(2*G_Sel+0) =\= 0
  ;
   active_last(2*G_Sel+1)/\2**I=\=0, 2**Event/\events_last(2*G_Sel+1) =\= 0 ->
    pen(10, Color)
  else
    pen(3, Color)
  ),
  R2 := 1.2*R,
  ellipse(X5-R2,Y5-R2,X5+R2,Y5+R2),
  line(X4a,Y4a,X3,Y3,X4b,Y4b).

arrow(I, J, R, Event):-
  calcCoords(X1,Y1,I),
  calcCoords(X2,Y2,J),
  D:= sqrt((X1-X2)**2+(Y1-Y2)**2),
  [A,B]:==[X1-X2,Y1-Y2]/D,
  Sign := (X1>X2; X1=X2, Y1<Y2->1 else -1),
  [X1,Y1]:==[X1,Y1]+(G_Zoom*Sign*14*(Event-1.5))*[B,-1*A],
  [X2,Y2]:==[X2,Y2]+(G_Zoom*Sign*14*(Event-1.5))*[B,-1*A],

  R1 := (Event=\=1, Event=\=2-> R-5*G_Zoom else R),
  [X3,Y3]:==[X2,Y2]+R1*[A,B],
  [X4,Y4]:==[X2,Y2]+(R+30*G_Zoom)*[A,B],
  [X4a,Y4a]:==[X4,Y4]+10*G_Zoom*[-1*B,A],
  [X4b,Y4b]:==[X4,Y4]+10*G_Zoom*[B,-1*A],
  makeColor(Event, _, Color),
  (active_last(2*G_Sel+0)/\2**I=\=0, active_last(2*G_Sel+1)/\2**J=\=0, 2**Event/\events_last(2*G_Sel+0) =\= 0
  ;
   active_last(2*G_Sel+1)/\2**I=\=0, active(G_Sel)/\2**J=\=0, 2**Event/\events_last(2*G_Sel+1) =\= 0 ->
    pen(10, Color)
  else
    pen(3, Color)
  ),
  line(X4a,Y4a,X3,Y3,X4b,Y4b),
  line(X1,Y1,X3,Y3).

calcCoords(X,Y,I):-
  (G_Sel<3; G_Sel>15 ->
    X := G_Zoom*(300 - 200*cos(I*pi/4)),
    Y := G_Zoom*(400 - 200*sin(I*pi/4))
  else
    coordinates(G_Sel, I, A, B),
    X := G_Zoom*(300 + 100*A),
    Y := G_Zoom*(400 + 100*B)
  ).

makeColor(0, 0, rgb(0,0,0)). % arrow, trace
makeColor(1, 1, Color):- makeColor2(Color, 255,0,0).
makeColor(2, 2, Color):- makeColor2(Color, 0,0,255).
makeColor(3, 4, Color):- makeColor2(Color, 0,128,0).
makeColor(4, 3, Color):- makeColor2(Color, 255,255,0).
makeColor(5, 5, Color):- makeColor2(Color, 0,255,255).
makeColor(6, 6, Color):- makeColor2(Color, 0,220,220).
makeColor(7, 7, Color):- makeColor2(Color, 255,220,220).

makeColor2(Color, R, G, B):-
  (observable(G_Sel) ->
    Color := rgb(R, G, B)
  else
    Color := rgb(R//2, G//2, B//2)
  ).

