% This program is created by students from University of Sofia

paper(1000,1200).

% data(SizeX,SizeY,[Blocks_X,Blocks_Y],Number,Lebal).
data(400,600,[3,1],1,"first").
data(290,700,[1,2],1,"second").
data(310,700,[2,2],1,"third").
data(310,600,[1,1],2,"fourth").
data(400,600,[1,1],1,"fifth").
data(290,700,[1,1],3,"sixth").

?- 
  G_I_dont_need_more_than:=10, % decisions
  G_Types:=0,
  array(typeX,30,0),
  array(typeY,30,0),
  array(type_DivX,30,0),
  array(type_DivY,30,0),
  array(typeN,30,0),
  array(last,30,0),
  G_Brojki:=0,
  array(brojki,30,0),
  array(r_brojki,30,0),
  array(color,30,255),
  color(1):=rgb(0,0,255),
  color(2):=rgb(0,255,0),
  color(3):=rgb(255,0,255),
  color(4):=rgb(0,255,255),
  color(5):=rgb(0,127,0),
  color(6):=rgb(255,255,255),
  read_data,
  array(x,100,0),
  array(y,100,0),
  array(w,100,0),
  array(h,100,0),
  array(type,100,0),
  array(index,100,0),
  array(x_index,100,0),
  pen(1,rgb(0,0,0)),
  G_Decision:=0,
  G_Min_Pages:=max_integer,
  G_Min_Pieces:=max_integer,
  G_Br:=1,
  G_N:=0,
  write("Wait while the program is calculating..."+G_Types), nl,
  chronometer_steps(),
  chronometer(),
  (calculate; true), nl,
  write("Wait a little bit more..."), nl,
  (optimisation(0, 0, 0, []); true),
  T:=chronometer(),
  Steps:=chronometer_steps(), nl, nl,
  G_Page := 1,
  G_Best := 1,
  G_Best_All := count_successes(best(_,_,_)),
  write(G_Best_All+" best from all "+G_N+" combinations,"), nl,
  (G_Decision>0->
    G_Show:=2,
    write(G_Min_Pages+" pages, "+G_Decision+" decisions, minimum "+G_Min_Pieces+" pieces."), nl,
    optimal(G_Decision, G_Page, Br, I, N)
  else
    G_Show:=1,
    write("There is no decision!\nSome pieces are too big to fit in the paper.", font_mask(_,rgb(255,0,0),_,_,_,bold,_,_)), nl,
    the_answer_with_number(G_Best, best(N,Br,I))
  ),
  nl, write("calculation is done for "+T+" seconds,"+Steps+" steps"), nl,
  window( title("Optimisation"), size(550,700)),
  update_text(N, Br, I).

read_data:-
  data(X,Y,[Blocks_X,Blocks_Y],N,Color),
  find_rect(Where,X,Y),
  brojki(Where):=brojki(Where)+Blocks_X*Blocks_Y*N,
  r_brojki(Where):=brojki(Where),
  for(DivX,Blocks_X,1,step(-1)),
  for(DivY,Blocks_Y,1,step(-1)),
  not(exist(DivX,DivY,X,Y)),
  typeX(G_Types):= DivX*X,
  typeY(G_Types):= DivY*Y,
  type_DivX(G_Types):=DivX,
  type_DivY(G_Types):=DivY,
  typeN(G_Types):=Where,
  G_Types:=G_Types+1,
  (DivX*X=\=DivY*Y->
    typeX(G_Types):= DivY*Y,
    typeY(G_Types):= DivX*X,
    type_DivX(G_Types):=DivY,
    type_DivY(G_Types):=DivX,
    typeN(G_Types):=Where,
    G_Types:=G_Types+1
  ),
  fail.
read_data.

exist(DivX,DivY,X,Y):-
  for(I, 0, G_Types-1),
  typeX(I)=:= DivX*X,
  typeY(I)=:= DivY*Y,
  type_DivX(I)=:=DivX,
  type_DivY(I)=:=DivY.

find_rect(Where,X,Y):-
  (where(Where,X,Y); where(Where,Y,X)->
    true
  else
    Where is G_Brojki,
    assert(where(Where,X,Y)),
    G_Brojki:=G_Brojki+1 
  ).

help(press):-
  message("Optimisation Help","Use arrows in order to scroll pages and decisions.",i).

l1(press):-change_menu(1).
l2(press):-change_menu(2).

change_menu(M):-
  G_Show=\=M,
  modify_menu(G_Menu1,G_Show,normal,_),
  G_Show:=M,
  modify_menu(G_Menu1,G_Show,checked,_),
  update_window(_),
  (G_Show=:=1->
    the_answer_with_number(G_Best, best(N,Br,I))
  else
    optimal(G_Decision, G_Page, Br, I, N)
  ),
  update_text(N, Br, I).

show(init):-
  menu( normal, action(l1), text("Best arrangements") ),
  menu( normal, action(l2), text("Decisions") ),
  modify_menu(G_Menu1,G_Show,checked,_).

make_lines(A,B,Tx,Ty,DivX,DivY):-
  for(I, 1, DivX-1),
  line(G_Zoom*(A+I*Tx),G_Zoom*B,G_Zoom*(A+I*Tx), G_Zoom*(B+Ty*DivY)),
  fail.
make_lines(A,B,Tx,Ty,DivX,DivY):-
  for(I, 1, DivY-1),
  line(G_Zoom*A,G_Zoom*(B+I*Ty),G_Zoom*(A+Tx*DivX), G_Zoom*(B+I*Ty)),
  fail.
make_lines(A,B,Tx,Ty,DivX,DivY).

put_labels(A,B,Tx,Ty,DivX,DivY,Type):-
  text_out(" "+DivX+"x"+DivY+" ", pos(10+G_Zoom*A, 10+G_Zoom*B)),
  I:=40,
  (G_Show=:=2, brojki(Type)>r_brojki(Type)->
    color_text(_, rgb(255,0,255)),
    text_out(" "+(brojki(Type)-r_brojki(Type))+" more ", pos(10+G_Zoom*A, I+G_Zoom*B)),
    color_text(_, 0),
    I:=I+20
  ),
  (data(Tx,Ty,_,_,Label); Tx=\=Ty, data(Ty,Tx,_,_,Label)),
  I:=I+20,
  text_out(" "+Label+" ", pos(10+G_Zoom*A, I+G_Zoom*B)),
  fail.

clean_brojki:-
  for(I, 0, G_Brojki-1),
  brojki(I):=0,
  fail.
clean_brojki.

calc_brojki:-
  clean_brojki,
  optimal(G_Decision, _, _, _, N),
  best(N, _, List),
  add_list(0, List).
calc_brojki.

add_list(N, [H|T]):-
  brojki(N):=brojki(N)+H,
  add_list(N+1, T).

win_func(init):-
  G_Menu1 := menu(pop_up, action(show), text("&Show") ),
  menu( right, action(help), text("&Help") ).

win_func(paint):-
  paper(X,Y),
  brush(rgb(255,255,0)),
  rect(0, 0, G_Zoom*X, G_Zoom*Y),
  (G_Show=:=1->
    the_answer_with_number(G_Best, best(N,_,_))
  else
    calc_brojki,
    optimal(G_Decision, G_Page, _, _, N)
  ),
  p(N,A,B,Type),
  Tx is typeX(Type)//type_DivX(Type),
  Ty is typeY(Type)//type_DivY(Type),
  brush(color(typeN(Type))),
  rect(G_Zoom*A, G_Zoom*B, G_Zoom*(A+typeX(Type)), G_Zoom*(B+typeY(Type))),
  make_lines(A,B,Tx,Ty,type_DivX(Type),type_DivY(Type)),
  put_labels(A,B,Tx,Ty,type_DivX(Type),type_DivY(Type), typeN(Type)).

win_func(size(X,Y)):-
  paper(A,B),
  G_Zoom := min(X/A,Y/B),
  update_window(_).

win_func(key_down(Key, Rep)):-
  G_Show=:=1,
  (Key=:=37 ->
    NewBest:=G_Best-Rep
  else (Key=:=39 ->
    NewBest:=G_Best+Rep
  else
    fail
  )),
  1=<NewBest, NewBest=<G_Best_All,
  G_Best:=NewBest,
  the_answer_with_number(G_Best, best(N,Br,List)),
  update_window(_),
  update_text(N, Br, List).
win_func(key_down(Key, Rep)):-
  G_Show=:=2,
  NewPage is G_Page,
  NewDecision is G_Decision,
  (Key=:=37 ->
    NewPage:=G_Page-Rep
  else (Key=:=39 ->
    NewPage:=G_Page+Rep
  else (Key=:=38 ->
    NewDecision:=G_Decision-Rep
  else (Key=:=40 ->
    NewDecision:=G_Decision+Rep
  else
    fail
  )))),
  (optimal(NewDecision, NewPage, Br, I, N)->
    true
  else
    NewPage>1, NewDecision=\=G_Decision,
    optimal(NewDecision, 1, Br, I, N),
    NewPage:=1
  ),
  G_Page:=NewPage,
  G_Decision:=NewDecision,
  update_window(_),
  update_text(N, Br, I).

update_text(N, Br, List):-
  G_Show=:=1,
  Text is print(List),
  set_text( "#"+N+". "+G_Best + " from all "+G_Best_All+" best arrangements, "+Br+" pieces, distribution: "+Text, _ ).
update_text(N, Br, I):-
  G_Show=:=2,
  All is count_successes(optimal(G_Decision, _, _, _, _)),
  set_text( G_Page + ". "+I+"x(#"+N+") from all "+All+" (Decision "+G_Decision+", "+Br+" pieces in "+G_Min_Pages+" pages)", _ ).

find_XY(Type,X,Y,W,H):-
  paper(A,B),
  for(I,0,G_Br-1),
  Y is y(index(I))+h(index(I)),
  Y>=last(Type),
  Y+H=<B,
  (Y=\=y(index(I+1))+h(index(I+1)); Y=:=0),
  for(J,0,G_Br-1),
  X is x(x_index(J))+w(x_index(J)),
  X+W=<A,
  (X=\=x(x_index(J+1))+w(x_index(J+1)), Y<y(x_index(J))+h(x_index(J)); X=:=0),
  not(intersect(I,X,Y,W,H)),
  !.

intersect(Last,X,Y,W,H):-
  for(I,Last+1,G_Br-1),
  x(index(I))+w(index(I))>X,
  X+W>x(index(I)),
  y(index(I))+h(index(I))>Y,
  Y+H>y(index(I)).

double(MaxA, MaxB, Type1):-
  for(Type, 0, G_Types-1),
  Type=\=Type1,
  brojki(typeN(Type))>0,
  W is typeX(Type),
  H is typeY(Type),
  find_XY(Type,X,Y,W,H),
  (Y<MaxB; Y=:=MaxB, X<MaxA).

not_finish():-
  for(Type, 0, G_Types-1),
  brojki(typeN(Type))>0,
  W is typeX(Type),
  H is typeY(Type),
  find_XY(Type,X,Y,W,H).

not_finish2():-
  for(X, 0, G_Brojki-1),
  brojki(X)>0.

sub_list([], _, _).
sub_list([H|T], I, A):-
  brojki(A) has_to brojki(A)-I*H,
  sub_list(T, I, A+1).

find_max([], 0, _).
find_max([H|T], Max2, A):-
  find_max(T, Max, A+1),
  (H>0, brojki(A)>0, 1+(brojki(A)-1)//H>Max->
    Max2 is 1+(brojki(A)-1)//H
  else
    Max2 is Max
  ).

sort(Pos) :-
  y(index(Pos-1))+h(index(Pos-1))>y(G_Br)+h(G_Br),
  !,
  index(Pos) has_to index(Pos-1),
  sort(Pos-1).

sort(Pos) :-
  index(Pos) has_to G_Br.

x_sort(Pos) :-
  A is x(x_index(Pos-1))+w(x_index(Pos-1)),
  B is x(G_Br)+w(G_Br),
  (A>B; A=:=B, y(x_index(Pos-1))+h(x_index(Pos-1))>y(G_Br)+h(G_Br)),
  !,
  x_index(Pos) has_to x_index(Pos-1),
  x_sort(Pos-1).

x_sort(Pos) :-
  x_index(Pos) has_to G_Br.

check(Pages3, Br3):-
  G_Min_Pages>Pages3, !.
check(Pages3, Br3):-
  G_Min_Pages=:=Pages3,
  not(G_Decision>=G_I_dont_need_more_than, G_Min_Pieces=<Br3).

optimisation(Begin, Pages, Br, Decision) :-
  best(N, Br2, List),
  N>Begin,
  find_max(List, Max, 0),
  for(I, Max, 1, step(-1)),
  Br3 is Br+I*Br2,
  Pages3 is Pages+I,
  check(Pages3, Br3),  %G_Min_Pages>=Pages3,
  sub_list(List, I, 0),
  (not_finish2()->
    optimisation(N, Pages3, Br3, [[I,N]|Decision])
  else
    %write(Pages3+", "),
    %write([[I,N]|Decision]),
    %write(", "+brojki(0)+", "+brojki(1)+", "+brojki(2)), nl,
    (G_Min_Pages>Pages3->
      G_Min_Pages:=Pages3,
      write(G_Min_Pages),
      G_Decision:=0,
      G_Min_Pieces:=max_integer,
      retractall(optimal(_,_,_,_,_))
    ),
    G_Decision:=G_Decision+1,
    Length is list_length(Decision)+1,
    (G_Min_Pieces>Br3->
      G_Min_Pieces:=Br3
    ),
    save_decision(Length, Br3, [[I,N]|Decision]),
    fail
  ).

calculate :-
  for(Type, 0, G_Types-1),
  brojki(typeN(Type))>=type_DivX(Type)*type_DivY(Type),
  (G_Br=:=1->
    write(Type)
  ),
  W is typeX(Type),
  H is typeY(Type),
  find_XY(Type,X,Y,W,H),
  x(G_Br) has_to X,
  y(G_Br) has_to Y,
  w(G_Br) has_to W,
  h(G_Br) has_to H,
  type(G_Br) has_to Type,
  sort(G_Br),
  x_sort(G_Br),
  G_Br has_to G_Br+1,
  brojki(typeN(Type)) has_to brojki(typeN(Type))-type_DivX(Type)*type_DivY(Type),
  last(Type) has_to Y,
  not(double(X, Y, Type)),
  (not_finish()->
    calculate
  else
    G_N:=G_N+1,
    (G_N mod 200=:=0->
      write(".")
    ),
    make_list(List, 0, G_Brojki-1),
    not(not_maximal(G_Br, List)),
    delete_other(List),
    Br is G_Br-1,
    assert(best(G_N, Br, List)),
    %write(w(1)+" "+w(2)+" "+w(3)+" "+w(4)+" "+w(5)+" "+w(6)+" "+w(7)+" "+w(8)+" "+w(9)+" "+w(10)),nl,
    %wait(1.5),win_func(paint),
    for(I, 1, Br),
    A is x(I),
    B is y(I),
    T is type(I),
    assert(p(G_N, A, B, T)),
    fail
  ).

save_decision(Page, Br, [D|T]):-
  Page2 is Page-1,
  save_decision(Page2, Br, T),
  assert(optimal(G_Decision, Page, Br|D)).
save_decision(_, _, []).

make_list([], A, B):-
  A>B, !.
make_list([H|T], A, B):-
  H is r_brojki(A)-brojki(A),
  make_list(T, A+1, B).

not_maximal(Br, L):-
  best(_, Br2, L2),
  smaller_than(L, L2),
  (not(L=L2); Br>=Br2).

delete_other(L):-
  best(N, Br, L2),
  smaller_than(L2, L),
  retract(best(N, Br, L2)),
  fail.
delete_other(_).

smaller_than([], []).
smaller_than([X|T1], [Y|T2]):-
  X=<Y,
  smaller_than(T1, T2).

the_answer_with_number(N, X) :- I:=0, X, I:=I+1, I=:=N, !.

